﻿using FreeRedis;

namespace ServiceCenter.Redis
{
    /// <summary>
    /// 链接集合
    /// </summary>
    public class RedisClientList
    {
        /// <summary>
        /// 连接集合
        /// </summary>
        /// <param name="key">连接标识</param>
        /// <param name="client">连接</param>
        /// <param name="connectionConfig">连接字符串</param>
        public RedisClientList(string key, RedisClient client, string connectionConfig)
        {
            Key = key;
            Client = client;
            ConnectionConfig = connectionConfig;
        }

        /// <summary>
        /// 连接标识
        /// </summary>
        public string Key { get; set; }

        /// <summary>
        /// 连接
        /// </summary>
        public RedisClient Client { get; set; }

        /// <summary>
        /// 连接字符串
        /// </summary>
        public string ConnectionConfig { get; set; }
    }
}
