﻿using System.ComponentModel;

namespace WCS.Entity.Protocol.SRM
{
    /// <summary>
    /// 堆垛机DB521
    /// </summary>
    /// <typeparam name="status">状态</typeparam>
    /// <typeparam name="autoStatus">运行模式</typeparam>
    /// <typeparam name="runStatus">运行状态</typeparam>
    /// <typeparam name="runSpeed">运行速度</typeparam>
    /// <typeparam name="depth">深度</typeparam>
    /// <typeparam name="taskType">任务类型</typeparam>
    public interface SRM521<status, autoStatus, runStatus, runSpeed, depth, taskType> : IProtocol
    {
        /// <summary>
        ///  状态
        /// </summary>
        [Description("状态")]
        status Status { get; set; }

        /// <summary>
        ///  自动状态
        /// </summary>
        [Description("自动状态")]
        autoStatus AutoStatus { get; set; }

        /// <summary>
        ///  运行状态
        /// </summary>
        [Description("运行状态")]
        runStatus RunStatus { get; set; }

        /// <summary>
        ///  任务起始行
        /// </summary>
        [Description("任务起始行")]
        short SLine { get; set; }

        /// <summary>
        ///  任务起始列
        /// </summary>
        [Description("任务起始列")]
        short SCol { get; set; }

        /// <summary>
        ///  任务起始层
        /// </summary>
        [Description("任务起始层")]
        short SLayer { get; set; }

        /// <summary>
        ///  任务起始深度
        /// </summary>
        [Description("任务起始深度")]
        depth SDepth { get; set; }

        /// <summary>
        ///  任务目标行
        /// </summary>
        [Description("任务目标行")]
        short ELine { get; set; }

        /// <summary>
        ///  任务目标列
        /// </summary>
        [Description("任务目标列")]
        short ECol { get; set; }

        /// <summary>
        ///  任务目标层
        /// </summary>
        [Description("任务目标层")]
        short ELayer { get; set; }

        /// <summary>
        ///  任务目标深度
        /// </summary>
        [Description("任务目标深度")]
        depth EDepth { get; set; }

        /// <summary>
        ///  任务号
        /// </summary>
        [Description("任务号")]
        int TaskNumber { get; set; }

        /// <summary>
        ///  凭证号
        /// </summary>
        [Description("凭证号")]
        short VoucherNo { get; set; }

        /// <summary>
        ///  当前行
        /// </summary>
        [Description("当前行")]
        short Line { get; set; }

        /// <summary>
        ///  当前列
        /// </summary>
        [Description("当前列")]
        short Col { get; set; }

        /// <summary>
        ///  当前层
        /// </summary>
        [Description("当前层")]
        short Layer { get; set; }

        /// <summary>
        ///  完成任务号
        /// </summary>
        [Description("完成任务号")]
        int TaskFinishiId { get; set; }

        /// <summary>
        ///  行走当前位置 MM
        /// </summary>
        [Description("行走当前位置 MM")]
        int TravelPos { get; set; }

        /// <summary>
        ///  提升当前位置 MM
        /// </summary>
        [Description("提升当前位置 MM")]
        int LiftPos { get; set; }

        /// <summary>
        ///  货叉当前位置 MM
        /// </summary>
        [Description("货叉当前位置 MM")]
        int ForkPos { get; set; }

        /// <summary>
        ///  运行速度
        /// </summary>
        [Description("运行速度")]
        runSpeed RunSpeed { get; set; }

        /// <summary>
        ///  任务类型
        /// </summary>
        [Description("任务类型")]
        taskType TaskType { get; set; }

        /// <summary>
        ///  运行总里程
        /// </summary>
        [Description("运行总里程")]
        float TotalKm { get; set; }

        /// <summary>
        ///  货物类型
        /// </summary>
        [Description("货物类型")]
        short GoodsType { get; set; }

        /// <summary>
        ///  运行总时长
        /// </summary>
        [Description("运行总时长")]
        float RunTime { get; set; }

        /// <summary>
        ///  备用
        /// </summary>
        [Description("备用")]
        int Res3 { get; set; }

        /// <summary>
        ///  备用
        /// </summary>
        [Description("备用")]
        int Res4 { get; set; }

        /// <summary>
        ///  备用
        /// </summary>
        [Description("备用")]
        int Res5 { get; set; }

        /// <summary>
        ///  备用
        /// </summary>
        [Description("备用")]
        int Res6 { get; set; }
    }
}
