﻿using System.ComponentModel;

namespace WCS.Entity.Protocol.Truss
{
    /// <summary>
    ///  桁架DB521 设备调度
    /// </summary>
    public interface Truss521<status, cmdType> : IProtocol
    {
        #region 工位一

        /// <summary>
        ///  目标地址（取货）
        /// </summary>
        [Description("目标地址（取货）")]
        public short DestPosition_1 { get; set; }

        /// <summary>
        ///  目标托盘（放置）
        /// </summary>
        [Description("目标托盘（放置）")]
        public short TargetPallte1 { get; set; }

        /// <summary>
        ///  任务1
        /// </summary>
        [Description("任务1")]
        public int Task1_1 { get; set; }

        /// <summary>
        ///  目标1
        /// </summary>
        [Description("目标1")]
        public short Dest1_1 { get; set; }

        /// <summary>
        ///  任务2
        /// </summary>
        [Description("任务2")]
        public int Task1_2 { get; set; }

        /// <summary>
        ///  目标2
        /// </summary>
        [Description("目标2")]
        public short Dest1_2 { get; set; }

        /// <summary>
        ///  任务3
        /// </summary>
        [Description("任务3")]
        public int Task1_3 { get; set; }

        /// <summary>
        ///  目标3
        /// </summary>
        [Description("目标3")]
        public short Dest1_3 { get; set; }

        /// <summary>
        ///  任务4
        /// </summary>
        [Description("任务4")]
        public int Task1_4 { get; set; }

        /// <summary>
        ///  目标4
        /// </summary>
        [Description("目标4")]
        public short Dest1_4 { get; set; }

        /// <summary>
        ///  任务5
        /// </summary>
        [Description("任务5")]
        public int Task1_5 { get; set; }

        /// <summary>
        ///  目标5
        /// </summary>
        [Description("目标5")]
        public short Dest1_5 { get; set; }

        /// <summary>
        ///  任务数量
        /// </summary>
        [Description("任务数量")]
        public short TaskSum1 { get; set; }

        #endregion 工位一

        #region 工位二

        /// <summary>
        ///  目标地址（取货）
        /// </summary>
        [Description("目标地址（取货）")]
        public short DestPosition_2 { get; set; }

        /// <summary>
        ///  目标托盘（放置）
        /// </summary>
        [Description("目标托盘（放置）")]
        public short TargetPallte2 { get; set; }

        /// <summary>
        ///  任务1
        /// </summary>
        [Description("任务1")]
        public int Task2_1 { get; set; }

        /// <summary>
        ///  目标1
        /// </summary>
        [Description("目标1")]
        public short Dest2_1 { get; set; }

        /// <summary>
        ///  任务2
        /// </summary>
        [Description("任务2")]
        public int Task2_2 { get; set; }

        /// <summary>
        ///  目标2
        /// </summary>
        [Description("目标2")]
        public short Dest2_2 { get; set; }

        /// <summary>
        ///  任务3
        /// </summary>
        [Description("任务3")]
        public int Task2_3 { get; set; }

        /// <summary>
        ///  目标3
        /// </summary>
        [Description("目标3")]
        public short Dest2_3 { get; set; }

        /// <summary>
        ///  任务4
        /// </summary>
        [Description("任务4")]
        public int Task2_4 { get; set; }

        /// <summary>
        ///  目标4
        /// </summary>
        [Description("目标4")]
        public short Dest2_4 { get; set; }

        /// <summary>
        ///  任务5
        /// </summary>
        [Description("任务5")]
        public int Task2_5 { get; set; }

        /// <summary>
        ///  目标5
        /// </summary>
        [Description("目标5")]
        public short Dest2_5 { get; set; }

        /// <summary>
        ///  任务数量
        /// </summary>
        [Description("任务数量")]
        public short TaskSum2 { get; set; }

        #endregion 工位二

        /// <summary>
        ///  状态
        /// </summary>
        [Description("状态")]
        public status Status { get; set; }

        /// <summary>
        ///  完成任务
        /// </summary>
        [Description("完成任务")]
        public cmdType CmdType { get; set; }

        /// <summary>
        ///  凭证号，触发信号
        /// </summary>
        [Description("凭证号，触发信号")]
        public short VoucherNo { get; set; }
    }
}
