using Newtonsoft.Json;
using PlcSiemens.Core.Extension;
using ServiceCenter;
using ServiceCenter.Logs;
using ServiceCenter.Redis;
using ServiceCenter.SqlSugars;
using SqlSugar;
using System.Text;
using WCS.Core;
using WCS.Entity;
using WCS.WorkEngineering;

namespace WCS.Service
{
    /// <summary>
    /// 
    /// </summary>
    public class Worker : BackgroundService
    {
        /// <summary>
        /// ¼
        /// </summary>
        private readonly ILogger<Worker> _logger;

        /// <summary>
        /// 캯
        /// </summary>
        /// <param name="logger">¼</param>
        public Worker(ILogger<Worker> logger)
        {
            _logger = logger;
        }

        public static readonly string WcsDlog = "WCSDlog";
        public static readonly string Wcsdb = "WCSDB";

        /// <summary>
        ///  ִ
        /// </summary>
        /// <param name="stoppingToken">ֹͣ</param>
        /// <returns></returns>
        protected override async Task ExecuteAsync(CancellationToken stoppingToken)
        {
            if (stoppingToken.IsCancellationRequested)
                return;

            #region ־

            //var logConfigText = RedisHub.Default.Check("LogConfigText") ?? throw new Exception("Redislog4net");
            //var logConfig = JsonConvert.DeserializeObject<LogConfig>(logConfigText);
            //LogHub.SetConfigInfo(logConfig!);

            #endregion ־

            _logger.LogInformation("WCSʼ");
            Configs.ProtocolProxyBaseType = typeof(ProtocolProxy);
            Encoding.RegisterProvider(CodePagesEncodingProvider.Instance);
            Configs.StringEncoding = Encoding.UTF8;
            var warehouseName = RedisHub.Default.Check("WarehouseName") ?? throw new Exception("Redisòֿ");
            if (string.IsNullOrEmpty(warehouseName)) throw new Exception("Redisòֿ");
            ServiceHub.SetWarehouseName(warehouseName);

            #region ʼݿ

            var dbConnectionStrings = RedisHub.Default.Check("DbConnectionStrings") ?? throw new Exception("Redisݿ");
            ServiceHub.DbConnectionStrings = JsonConvert.DeserializeObject<List<DataBaseConnectionString>>(dbConnectionStrings);
            if (ServiceHub.DbConnectionStrings != null)
            {
                if (ServiceHub.DbConnectionStrings.All(v => v.Key != Wcsdb)) throw new Exception("DbConnectionStringsWCSݿַ");
                if (ServiceHub.DbConnectionStrings.All(v => v.Key == Wcsdb && !v.IsDefault)) throw new Exception("DbConnectionStringsWCSݿΪĬݿ");
                // if (ServiceHub.DbConnectionStrings.All(v => v.Key != WcsDlog)) throw new Exception("DbConnectionStringsWCS־ݿַ");
            }

            //Ϣ
            List<ConnectionConfig> connectionConfigs = new List<ConnectionConfig>();
            foreach (var connectionString in ServiceHub.DbConnectionStrings!)
            {
                connectionConfigs.Add(new ConnectionConfig()
                {
                    ConfigId = connectionString.Key,
                    ConnectionString = connectionString.ConnectionString,//ӷִ
                    DbType = connectionString.DbType,//ݿ
                    IsAutoCloseConnection = true,//trueҪֶclose
                });
            };
            SqlSugarHelper.SetDb(new SqlSugarScope(connectionConfigs));

            //ʼݿ
            SqlSugarHelper.Do(db =>
            {
                foreach (var connectionString in ServiceHub.DbConnectionStrings!)
                {
                    var _db = db.Connect.GetConnectionScope(connectionString.Key);
                    switch (connectionString.Key)
                    {
                        case "WCSDB"://WCSݿ
                            SqlSugarHelper.SetDefault(connectionString.Key);
                            _db.CodeFirst.InitTables(typeof(WCS_PlcData));
                            _db.CodeFirst.InitTables(typeof(WCS_TaskInfo));
                            _db.CodeFirst.InitTables(typeof(WCS_TaskDtl));
                            _db.CodeFirst.InitTables(typeof(WCS_TaskOld));
                            _db.CodeFirst.InitTables(typeof(WCS_AgvTaskInfo));

                            break;

                        case "WCSDlog"://WCS־ݿ
                            SqlSugarHelper.SetDefault(connectionString.Key);
                            //_db.CodeFirst.InitTables(typeof(w));
                            //_db.CodeFirst.InitTables(typeof(WCS_TaskInfo));
                            //_db.CodeFirst.InitTables(typeof(WCS_TaskDtl));
                            //_db.CodeFirst.InitTables(typeof(WCS_TaskOld));
                            //_db.CodeFirst.InitTables(typeof(WCS_AgvTaskInfo));
                            break;

                        default: //
                            break;
                    };
                };
            });

            #endregion ʼݿ

         

            #region ʼ豸Ϣ

            WorkStart.InitializeDeviceInfo();

            #endregion ʼ豸Ϣ

            #region ʼPLCPLCȡЭ

            //PLC
            Configs.PLCAccessorCreater = new PLCAccessors.PLCAccessorsCreater();

            try
            {
                #region е

                World.StartAll();

                #endregion е

                _logger.LogInformation("WCSɹ");
            }
            catch (Exception ex)
            {
                _logger.LogError("WCSʧ{0}", ex.Message);
            }

            #endregion ʼPLCPLCȡЭ

            LogHub.init();
        }
    }
}
