﻿using System.ComponentModel.DataAnnotations;

namespace WCS.WorkEngineering.WebApi.Models.WMS.Request
{
    public class ApplyStockOutTaskRequest
    {
        /// <summary>
        /// 出库位置
        /// </summary>
        [Required(ErrorMessage = "{0} 不可为空")]
        public string OutEndPostion { get; set; }

        /// <summary>
        /// 出库类型（0.无效参数；1.物料出库；2.空托盘出库；3.空工字轮出库；）
        /// </summary>
        [Required(ErrorMessage = "{0} 不可为空")]
        public int OutType { get; set; }

        /// <summary>
        /// 仓库编码
        /// </summary>
        [Required(ErrorMessage = "{0} 不可为空")]
        public string WarehouseCode { get; set; }

        /// <summary>
        /// 巷道
        /// </summary>
        public string Tunnel { get; set; } = "";

        /// <summary>
        /// 备用
        /// </summary>
        public string Memo1 { get; set; } = "";

        /// <summary>
        /// 备用
        /// </summary>
        public string Memo2 { get; set; } = "";
    }
}
