﻿using System.ComponentModel.DataAnnotations;

namespace WCS.WorkEngineering.WebApi.Models.WMS.Request
{
    /// <summary>
    /// 获取入库任务请求实体
    /// </summary>
    public class I_WCS_GetInTaskRequest
    {
        /// <summary>
        /// 容器编号
        /// </summary>
        [Required(ErrorMessage = "{0} 不可为空")]
        public string ContainerBarCode { get; set; }

        /// <summary>
        /// 容器类型
        /// </summary>
        [Required(ErrorMessage = "{0} 不可为空")]
        public int ContainerType { get; set; }

        /// <summary>
        /// 物料条码
        /// </summary>
        public string MatBarCode { get; set; }

        /// <summary>
        /// 仓库编码
        /// </summary>
        [Required(ErrorMessage = "{0} 不可为空")]
        public string WareHouseId { get; set; }

        /// <summary>
        /// 设备编号
        /// </summary>
        [Required(ErrorMessage = "{0} 不可为空")]
        public string EquipmentNo { get; set; }

        /// <summary>
        /// 目标位置
        /// </summary>
        public string EndPostion { get; set; }

        /// <summary>
        /// 货叉（直接申请货位使用）
        /// </summary>
        public int ForkNum { get; set; }

        public string Memo1 { get; set; }
        public string Memo2 { get; set; }
        public string Memo3 { get; set; }
        public string Memo4 { get; set; }
    }
}
