﻿namespace WCS.WorkEngineering.WebApi.Models.WMS.Response
{
    public class I_WCS_GetInTaskResponse : WcsContractApiResponse
    {
        /// <summary>
        /// WMS任务号
        /// </summary>
        public string WMSTaskNum { get; set; } = "0";

        /// <summary>
        /// 任务类型(1：入库2：出库3：移库4：移动(搬运) 5：异常 )
        /// </summary>
        public int TaskType { get; set; }

        /// <summary>
        /// 仓库名称
        /// </summary>
        public string WareHouseName { get; set; } = "";

        /// <summary>
        /// 入库巷道(集合巷道，由WCS自行判断入到哪一个巷道，最前面的最优先。)
        /// </summary>
        public string TunnelNum { get; set; } = "";

        /// <summary>
        /// 目标位置(入库该地址为srm.如果是移动任务，该地址为WCS传递的目标位置。)
        /// </summary>
        public string EndPostion { get; set; } = "";

        public int Priority { get; set; } = 0;

        /// <summary>
        /// 产品编码（半成品入库使用）
        /// </summary>
        public string ContainerCode { get; set; } = "";

        /// <summary>
        /// 0默认值  1载货  2空盘（包含一个托盘或一摞两种情况）
        /// </summary>
        public int ContainerType { get; set; } = 0;

        public string Memo1 { get; set; } = "";
        public string Memo2 { get; set; } = "";
        public string Memo3 { get; set; } = "";
    }
}
